package com.jiuqi.mde;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.jiuqi.mde.MDEDataInfo;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

public final class MDEDataInfoSet {
  private ArrayList datasets = new ArrayList(128);
  
  private Map nameSearch = new HashMap<Object, Object>(127);
  
  public int size() {
    return this.datasets.size();
  }
  
  public void clear() {
    this.datasets.clear();
    this.nameSearch.clear();
  }
  
  public MDEDataInfo get(int index) {
    return this.datasets.get(index);
  }
  
  public MDEDataInfo find(String name) {
    return (MDEDataInfo)this.nameSearch.get(name);
  }
  
  public void add(MDEDataInfo dataset) {
    if (!this.nameSearch.containsKey(dataset.getName())) {
      this.datasets.add(dataset);
      this.nameSearch.put(dataset.getName(), dataset);
    } 
  }
  
  public void add(int index, MDEDataInfo dataset) {
    if (!this.nameSearch.containsKey(dataset.getName())) {
      this.datasets.add(index, dataset);
      this.nameSearch.put(dataset.getName(), dataset);
    } 
  }
  
  public void add(com.jiuqi.mde.MDEDataInfoSet datasets) {
    for (int i = 0; i < datasets.size(); i++)
      add(datasets.get(i)); 
  }
  
  public void remove(int index) {
    MDEDataInfo dataset = this.datasets.get(index);
    this.nameSearch.remove(dataset.getName());
    this.datasets.remove(index);
  }
  
  public void remove(MDEDataInfo dataset) {
    this.datasets.remove(dataset);
    this.nameSearch.remove(dataset.getName());
  }
  
  public int indexOf(MDEDataInfo dataset) {
    for (int i = 0; i < this.datasets.size(); i++) {
      MDEDataInfo dim = this.datasets.get(i);
      if (dim == dataset || dim.getName().equals(dataset.getName()))
        return i; 
    } 
    return -1;
  }
  
  public Object clone() {
    com.jiuqi.mde.MDEDataInfoSet result = new com.jiuqi.mde.MDEDataInfoSet();
    result.add(this);
    return result;
  }
  
  public void sortByName() {
    for (int i = 1; i < this.datasets.size(); i++) {
      MDEDataInfo dataset = this.datasets.get(i);
      int start = 0;
      int stop = i - 1;
      int flag = -1;
      while (start <= stop) {
        int middle = start + stop >> 1;
        flag = dataset.getName().compareTo(((MDEDataInfo)this.datasets
            .get(middle)).getName());
        if (flag > 0) {
          start = middle + 1;
          continue;
        } 
        if (flag < 0) {
          stop = middle - 1;
          continue;
        } 
        start = middle;
        break;
      } 
      if (start < i) {
        for (int k = i; k > start; k--)
          this.datasets.set(k, this.datasets.get(k - 1)); 
        this.datasets.set(start, dataset);
      } 
    } 
  }
}
